﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Controls;

public partial class PollArchive : BlogEngine.Core.Web.Controls.BlogBasePage
{
    private double totalVote;

    protected void Page_Load(object sender, EventArgs e)
    {
        Page.Title = "Lista de votaciones";

        Polls_dl.DataSource = SortPolls(Polls.FillPolls(), Sort_ddl.SelectedValue, Direction_ddl.SelectedValue);
        Polls_dl.DataBind();
    }

    protected void Answers_rpt_ItemDataBound(object sender, RepeaterItemEventArgs e)
    {
        if (e.Item.ItemType == ListItemType.Item || e.Item.ItemType == ListItemType.AlternatingItem)
        {
            double vote = Convert.ToDouble(((Answer)e.Item.DataItem).Vote);
            double percent = 0;

            if (vote != 0)
            {
                percent = (vote * 100) / totalVote;
            }

            ((System.Web.UI.HtmlControls.HtmlContainerControl)e.Item.FindControl("Percent_div")).InnerText = percent.ToString("F01") + "%";
            ((System.Web.UI.HtmlControls.HtmlContainerControl)e.Item.FindControl("Vote_div")).InnerText = "(" + vote.ToString() + ")";

            double width = (percent * 70) / 100;
            System.Globalization.CultureInfo ci = new System.Globalization.CultureInfo("en-us");
            ((System.Web.UI.HtmlControls.HtmlContainerControl)e.Item.FindControl("Progress_div")).Style["width"] = percent <= 1 ? "1px" : (width + 1).ToString("F01", ci) + "%";
        }
    }

    protected void Polls_dl_ItemCreated(object sender, DataListItemEventArgs e)
    {
        if (e.Item.ItemType == ListItemType.Item || e.Item.ItemType == ListItemType.AlternatingItem)
        {
            totalVote = ((Poll)(e.Item.DataItem)).TotalVote;
        }
    }

    private List<Poll> SortPolls(List<Poll> polls, string sortType, string sortDirection)
    {
        if (sortType.ToLower() == "id")
            polls.Sort(delegate(Poll comparePoll1, Poll comparePoll2) { return comparePoll1.Id.CompareTo(comparePoll2.Id); });
        else if (sortType.ToLower() == "date")
            polls.Sort(delegate(Poll comparePoll1, Poll comparePoll2) { return comparePoll1.DateCreated.CompareTo(comparePoll2.DateCreated); });
        else if (sortType.ToLower() == "question")
            polls.Sort(delegate(Poll comparePoll1, Poll comparePoll2) { return comparePoll1.Question.CompareTo(comparePoll2.Question); });
        else if (sortType.ToLower() == "vote")
            polls.Sort(delegate(Poll comparePoll1, Poll comparePoll2) { return comparePoll1.TotalVote.CompareTo(comparePoll2.TotalVote); });
        else
            polls.Sort(delegate(Poll comparePoll1, Poll comparePoll2) { return comparePoll1.DateCreated.CompareTo(comparePoll2.DateCreated); });

        if (sortDirection.ToLower() == "descending")
        {
            polls.Reverse();
        }
        return polls;
    }
}
